/*
   prototypes for energy_par.c
*/

#ifndef __VIENNA_RNA_PACKAGE_ENERGY_PAR_RD_H__
#define __VIENNA_RNA_PACKAGE_ENERGY_PAR_RD_H__

#include "energy_const.h"

#define PUBLIC


extern double lxc37_RD;   /* parameter for logarithmic loop
			  energy extrapolation            */

extern int stack37_RD[NBPAIRS+1][NBPAIRS+1];
extern int stackdH_RD[NBPAIRS+1][NBPAIRS+1]; /* stack enthalpies */
extern int entropies[NBPAIRS+1][NBPAIRS+1];  /* not used anymore */

extern int hairpin37_RD[31];
extern int hairpindH_RD[31];
extern int bulge37_RD[31];
extern int bulgedH_RD[31];
extern int internal_loop37_RD[31];
extern int internal_loopdH_RD[31];
extern int internal2_energy_RD;
extern int old_mismatch_37_RD[NBPAIRS+1][5][5];
extern int mismatchI37_RD[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatchIdH_RD[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch1nI37_RD[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch23I37_RD[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch1nIdH_RD[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch23IdH_RD[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatchH37_RD[NBPAIRS+1][5][5];  /* same for hairpins */
extern int mismatchM37_RD[NBPAIRS+1][5][5];  /* same for multiloops */
extern int mismatchHdH_RD[NBPAIRS+1][5][5];  /* same for hairpins */
extern int mismatchMdH_RD[NBPAIRS+1][5][5];  /* same for multiloops */
extern int mismatchExt37_RD[NBPAIRS+1][5][5];
extern int mismatchExtdH_RD[NBPAIRS+1][5][5];

extern int dangle5_37_RD[NBPAIRS+1][5];      /* 5' dangle exterior of pair */
extern int dangle3_37_RD[NBPAIRS+1][5];      /* 3' dangle */
extern int dangle3_dH_RD[NBPAIRS+1][5];       /* corresponding enthalpies */
extern int dangle5_dH_RD[NBPAIRS+1][5];

extern int int11_37_RD[NBPAIRS+1][NBPAIRS+1][5][5]; /* 1x1 interior loops */
extern int int11_dH_RD[NBPAIRS+1][NBPAIRS+1][5][5];

extern int int21_37_RD[NBPAIRS+1][NBPAIRS+1][5][5][5]; /* 2x1 interior loops */
extern int int21_dH_RD[NBPAIRS+1][NBPAIRS+1][5][5][5];

extern int int22_37_RD[NBPAIRS+1][NBPAIRS+1][5][5][5][5]; /* 2x2 interior loops */
extern int int22_dH_RD[NBPAIRS+1][NBPAIRS+1][5][5][5][5];

/* constants for linearly destabilizing contributions for multi-loops
   F = ML_closing + ML_intern*(k-1) + ML_BASE*u  */
extern int ML_BASE37_RD;
extern int ML_BASEdH_RD;
extern int ML_closing37_RD;
extern int ML_closingdH_RD;
extern int ML_intern37_RD;
extern int ML_interndH_RD;

extern int TripleC37_RD;
extern int TripleCdH_RD;
extern int MultipleCA37_RD;
extern int MultipleCAdH_RD;
extern int MultipleCB37_RD;
extern int MultipleCBdH_RD;

/* Ninio-correction for asymmetric internal loops with branches n1 and n2 */
/*    ninio_energy = min{max_ninio, |n1-n2|*F_ninio[min{4.0, n1, n2}] } */
extern int  MAX_NINIO_RD;                   /* maximum correction */
extern int ninio37_RD;
extern int niniodH_RD;
/* penalty for helices terminated by AU (actually not GC) */
extern int TerminalAU37_RD;
extern int TerminalAUdH_RD;
/* penalty for forming bi-molecular duplex */
extern int DuplexInit37_RD;
extern int DuplexInitdH_RD;
/* stabilizing contribution due to special hairpins of size 4 (tetraloops) */
extern char Tetraloops_RD[];  /* string containing the special tetraloops */
extern int  Tetraloop37_RD[];  /* Bonus energy for special tetraloops */
extern int  TetraloopdH_RD[];
extern char Triloops_RD[];    /* string containing the special triloops */
extern int  Triloop37_RD[]; /* Bonus energy for special Triloops */
extern int  TriloopdH_RD[]; /* Bonus energy for special Triloops */
extern char Hexaloops_RD[];    /* string containing the special triloops */
extern int  Hexaloop37_RD[]; /* Bonus energy for special Triloops */
extern int  HexaloopdH_RD[]; /* Bonus energy for special Triloops */

#endif
