/*
    Automatically generated from parameter files shipped with
    the RNAstructure program package.

    See also http://rna.urmc.rochester.edu/NNDB/index.html for
    a detailed description of the parameters we use here.

    (c) Ronny Lorenz 2016
*/

/*
     Current free energy parameters are summarized in:

     D.H. Turner and D.H Mathews
     "NNDB: the nearest neighbor parameter database for predicting stability of
      nucleic acid secondary structure"
     Nucleic Acids Res. 2010 Jan; 38(Database issue): D280-D282.

     D.H. Mathews, M.D. Disney, J.L. Childs, S.J. Schroeder, M. Zuker, D.H. Turner
     "Incorporating chemical modification constraints into a dynamic programming
      algorithm for prediction of RNA secondary structure"
     Proc. Natl Acad. Sci. USA. 2004; 101:7287-7292

     D.H. Mathews, J. Sabina, M. Zuker, D.H. Turner
     "Expanded sequence dependence of thermodynamic parameters improves
     prediction of RNA secondary structure"
     JMB, 288, pp 911-940, 1999

     Enthalpies taken from:

     A. Walter, D Turner, J Kim, M Lyttle, P M"uller, D Mathews, M Zuker
     "Coaxial stacking of helices enhances binding of oligoribonucleotides.."
     PNAS, 91, pp 9218-9222, 1994

     D.H. Turner, N. Sugimoto, and S.M. Freier.
     "RNA Structure Prediction",
     Ann. Rev. Biophys. Biophys. Chem. 17, 167-192, 1988.

     John A.Jaeger, Douglas H.Turner, and Michael Zuker.
     "Improved predictions of secondary structures for RNA",
     PNAS, 86, 7706-7710, October 1989.

     L. He, R. Kierzek, J. SantaLucia, A.E. Walter, D.H. Turner
     "Nearest-Neighbor Parameters for GU Mismatches...."
     Biochemistry 1991, 30 11124-11132

     A.E. Peritz, R. Kierzek, N, Sugimoto, D.H. Turner
     "Thermodynamic Study of Internal Loops in Oligoribonucleotides..."
     Biochemistry 1991, 30, 6428--6435
*/

/* RNAfold parameters v2.x */
/* RNA/DNA hybrid parameters */


#include "ViennaRNA/energy_const.h"

#define NST 0     /* Energy for nonstandard stacked pairs */
#define DEF -50   /* Default terminal mismatch, used for I */
                  /* and any non_pairing bases */
#define NSM 0     /* terminal mismatch for non standard pairs */

#define PUBLIC

PUBLIC double lxc37_RD     = 107.90;
PUBLIC double lxcdH_RD     =  50.00;
PUBLIC int ML_intern37_RD  =    -20;
PUBLIC int ML_interndH_RD  =   -110;
PUBLIC int ML_closing37_RD =    615;
PUBLIC int ML_closingdH_RD =   1950;
PUBLIC int ML_BASE37_RD    =     10;
PUBLIC int ML_BASEdH_RD    =      0;
PUBLIC int MAX_NINIO_RD    =    300;
PUBLIC int ninio37_RD      =     50;
PUBLIC int niniodH_RD      =    160;
PUBLIC int TerminalAU37_RD =     25;
PUBLIC int TerminalAUdH_RD =    345;
PUBLIC int DuplexInit37_RD =    255;
PUBLIC int DuplexInitdH_RD =   -180;

PUBLIC int TripleC37_RD    =     75;
PUBLIC int TripleCdH_RD    =    930;
PUBLIC int MultipleCA37_RD =     15;
PUBLIC int MultipleCAdH_RD =    170;
PUBLIC int MultipleCB37_RD =     80;
PUBLIC int MultipleCBdH_RD =    380;

PUBLIC int GQuadAlpha37_RD = -1800;
PUBLIC int GQuadAlphadH_RD = -11934;
PUBLIC int GQuadBeta37_RD  = 1200;
PUBLIC int GQuadBetadH_RD  = 0;
PUBLIC int stack37_RD[NBPAIRS+1][NBPAIRS+1] = 
/*     NP      CG      GC      GT      UG      AT      UA      NN        */
{{    INF,    INF,    INF,    INF,    INF,    INF,    INF,    INF} /* NP */
,{    INF,   -170,   -210,      0,      0,    -90,    -90,      0} /* CG */
,{    INF,   -290,   -270,      0,      0,   -110,   -130,      0} /* GC */
,{    INF,      0,      0,      0,      0,      0,      0,      0} /* GT */
,{    INF,      0,      0,      0,      0,      0,      0,      0} /* UG */
,{    INF,   -180,   -210,      0,      0,    -90,   -100,      0} /* AT */
,{    INF,   -160,   -150,      0,      0,    -20,    -60,      0} /* UA */
,{    INF,      0,      0,      0,      0,      0,      0,      0} /* NN */
};
PUBLIC int stackdH_RD[NBPAIRS+1][NBPAIRS+1] = 
/*     NP      CG      GC      GT      UG      AT      UA      NN        */
{{    INF,    INF,    INF,    INF,    INF,    INF,    INF,    INF} /* NP */
,{    INF,  -1630,   -930,      0,      0,   -700,   -900,      0} /* CG */
,{    INF,  -1280,   -800,      0,      0,   -780,   -550,      0} /* GC */
,{    INF,      0,      0,      0,      0,      0,      0,      0} /* GT */
,{    INF,      0,      0,      0,      0,      0,      0,      0} /* UG */
,{    INF,   -910,   -590,      0,      0,   -830,   -780,      0} /* AT */
,{    INF,  -1040,   -860,      0,      0,  -1150,   -780,      0} /* UA */
,{    INF,      0,      0,      0,      0,      0,      0,      0} /* NN */
};
PUBLIC int hairpin37_RD[31] = {   INF,   INF,   INF,    440,    450,    460,    480,    510,    485,    535,    545,    555,    565,    575,    585,    595,    605,    615,    620,    630,    635,    645,    650,    660,    665,    675,    680,    685,    695,    700,    710};
PUBLIC int hairpindH_RD[31] = {   INF,   INF,   INF,     35,    125,   -425,   -980,   -615,   -850,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455,   -455};
PUBLIC int bulge37_RD[31] = {   INF,    335,    255,    285,    315,    350,    380,    400,    410,    420,    430,    445,    450,    460,    470,    480,    485,    490,    495,    500,    510,    510,    520,    520,    525,    530,    530,    540,    545,    545,    550};
PUBLIC int bulgedH_RD[31] = {   INF,   1475,    325,    240,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350,   -350};
PUBLIC int internal_loop37_RD[31] = {   INF,   INF,   INF,   INF,    210,    275,    295,    310,    325,    335,    350,    360,    365,    375,    385,    390,    400,    405,    410,    415,    425,    430,    435,    435,    445,    445,    450,    455,    460,    465,    465};
PUBLIC int internal_loopdH_RD[31] = {   INF,   INF,   INF,   INF,   -360,   -340,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65,    -65};
PUBLIC int mismatchI37_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -40,    -85,      0} /* A */
 ,{      0,    -40,    -25,      0,    -35} /* C */
 ,{      0,   -100,      0,    -95,    -50} /* G */
 ,{      0,      0,    -30,    -45,    -75} /* U/T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -35,    -80,      0} /* A */
 ,{      0,    -50,    -30,      0,    -35} /* C */
 ,{      0,   -100,      0,   -100,    -40} /* G */
 ,{      0,      0,    -30,    -45,    -75} /* U/T */
 }
,/* GT */
 {{     25,     25,     25,     10,     25} /* E */
 ,{     25,     10,     25,    -30,      5} /* A */
 ,{     25,     25,     25,    -10,     25} /* C */
 ,{     10,    -40,    -10,    -40,     10} /* G */
 ,{     25,     10,     25,     10,     -5} /* U/T */
 }
,/* UG */
 {{     25,     25,     25,     10,     25} /* E */
 ,{     25,     10,     25,    -30,     10} /* A */
 ,{     25,     25,     25,     -5,     25} /* C */
 ,{     10,    -40,    -15,    -40,     10} /* G */
 ,{     25,     10,     25,     10,     -5} /* U/T */
 }
,/* AT */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,      0,     20,    -30,     35} /* A */
 ,{     35,      5,     25,     35,     20} /* C */
 ,{     35,    -45,     35,    -35,     10} /* G */
 ,{     35,     35,     20,     10,    -15} /* U/T */
 }
,/* UA */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,      5,     15,    -30,     35} /* A */
 ,{     35,     10,     25,     35,     10} /* C */
 ,{     35,    -45,     35,    -35,     10} /* G */
 ,{     35,     35,     20,      5,    -10} /* U/T */
 }
,/* NN */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     10,     25,    -30,     35} /* A */
 ,{     35,     25,     25,     35,     25} /* C */
 ,{     35,    -40,     35,    -35,     10} /* G */
 ,{     35,     35,     25,     10,     -5} /* U/T */
 }
};
PUBLIC int mismatchIdH_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{    -70,   -230,   -210,    -95,   -250} /* E */
 ,{   -210,   -230,   -210,   -405,   -250} /* A */
 ,{   -210,   -230,   -210,   -235,   -250} /* C */
 ,{    -70,   -610,   -210,    -95,   -250} /* G */
 ,{   -210,   -230,   -210,   -235,   -540} /* U/T */
 }
,/* GC */
 {{     95,   -310,   -165,   -115,    -45} /* E */
 ,{    -45,   -310,   -165,   -425,    -45} /* A */
 ,{    -45,   -310,   -165,   -255,    -45} /* C */
 ,{     95,   -690,   -165,   -115,    -45} /* G */
 ,{    -45,   -310,   -165,   -255,   -335} /* U/T */
 }
,/* GT */
 {{    510,    100,    245,    300,    365} /* E */
 ,{    365,    100,    245,    -10,    365} /* A */
 ,{    365,    100,    245,    155,    365} /* C */
 ,{    510,   -280,    245,    300,    365} /* G */
 ,{    365,    100,    245,    155,     75} /* U/T */
 }
,/* UG */
 {{    510,    365,    335,    430,    -40} /* E */
 ,{    365,    365,    335,    120,    -40} /* A */
 ,{    365,    365,    335,    285,    -40} /* C */
 ,{    510,    -15,    335,    430,    -40} /* G */
 ,{    365,    365,    335,    285,   -330} /* U/T */
 }
,/* AT */
 {{    655,    450,    510,    630,    465} /* E */
 ,{    510,    450,    510,    320,    465} /* A */
 ,{    510,    450,    510,    485,    465} /* C */
 ,{    655,     70,    510,    630,    465} /* G */
 ,{    510,    450,    510,    485,    175} /* U/T */
 }
,/* UA */
 {{    510,    365,    335,    430,    -40} /* E */
 ,{    365,    365,    335,    120,    -40} /* A */
 ,{    365,    365,    335,    285,    -40} /* C */
 ,{    510,    -15,    335,    430,    -40} /* G */
 ,{    365,    365,    335,    285,   -330} /* U/T */
 }
,/* NN */
 {{    655,    450,    510,    630,    465} /* E */
 ,{    510,    450,    510,    320,    465} /* A */
 ,{    510,    450,    510,    485,    465} /* C */
 ,{    655,     70,    510,    630,    465} /* G */
 ,{    510,    450,    510,    485,    175} /* U/T */
 }
};
PUBLIC int mismatchH37_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{    -40,    -50,    -55,    -50,    -40} /* E */
 ,{    -70,   -125,   -115,   -115,    -75} /* A */
 ,{    -40,    -90,    -80,    -50,    -75} /* C */
 ,{    -75,   -165,    -75,   -165,   -125} /* G */
 ,{    -50,    -50,   -100,    -95,   -150} /* U/T */
 }
,/* GC */
 {{    -25,    -55,    -35,    -55,    -25} /* E */
 ,{    -55,   -105,   -110,   -105,    -75} /* A */
 ,{    -25,   -105,    -65,    -55,    -60} /* C */
 ,{    -75,   -175,    -75,   -160,   -115} /* G */
 ,{    -50,    -55,    -80,   -100,   -125} /* U/T */
 }
,/* GT */
 {{      0,      0,    -20,    -30,    -20} /* E */
 ,{      0,    -15,    -35,    -40,    -55} /* A */
 ,{    -15,    -15,    -20,    -50,    -20} /* C */
 ,{    -50,    -75,    -70,    -80,    -50} /* G */
 ,{    -15,    -30,    -25,    -30,    -60} /* U/T */
 }
,/* UG */
 {{    -10,    -20,    -15,    -35,    -10} /* E */
 ,{    -25,    -50,    -25,    -55,    -40} /* A */
 ,{    -10,    -20,    -15,    -50,    -10} /* C */
 ,{    -40,    -70,    -65,    -80,    -40} /* G */
 ,{    -15,    -35,    -15,    -35,    -55} /* U/T */
 }
,/* AT */
 {{     -5,     -5,    -10,     -5,    -10} /* E */
 ,{    -15,    -50,    -40,    -40,    -25} /* A */
 ,{     -5,    -35,    -20,     -5,    -25} /* C */
 ,{    -25,    -90,    -25,    -75,    -50} /* G */
 ,{     -5,     -5,    -30,    -30,    -80} /* U/T */
 }
,/* UA */
 {{      0,    -10,     -5,    -10,      0} /* E */
 ,{    -15,    -55,    -35,    -50,    -15} /* A */
 ,{      0,    -35,    -15,    -10,    -25} /* C */
 ,{    -15,   -105,    -15,    -95,    -40} /* G */
 ,{     -5,    -10,    -20,    -40,    -60} /* U/T */
 }
,/* NN */
 {{     10,     10,     -5,     -5,      0} /* E */
 ,{     10,    -15,    -25,    -40,    -15} /* A */
 ,{      0,    -15,    -15,     -5,    -10} /* C */
 ,{    -15,    -70,    -15,    -75,    -40} /* G */
 ,{     -5,     -5,    -15,    -30,    -55} /* U/T */
 }
};
PUBLIC int mismatchHdH_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{     70,   -515,     70,   -515,   -385} /* E */
 ,{   -490,   -685,   -490,   -515,   -530} /* A */
 ,{   -345,   -515,   -380,   -520,   -385} /* C */
 ,{     70,   -930,     70,   -695,   -530} /* G */
 ,{   -475,   -515,   -475,   -520,   -970} /* U/T */
 }
,/* GC */
 {{    -20,   -570,   -140,   -535,   -245} /* E */
 ,{   -245,   -570,   -365,   -535,   -245} /* A */
 ,{    -20,   -670,   -140,   -615,   -255} /* C */
 ,{   -245,   -955,   -365,   -565,   -245} /* G */
 ,{    -60,   -670,   -180,   -615,   -585} /* U/T */
 }
,/* GT */
 {{    600,    -80,    480,    -25,    400} /* E */
 ,{    400,   -135,    280,    -85,    400} /* A */
 ,{    600,    -80,    480,    -25,    285} /* C */
 ,{    400,   -285,    280,    -85,    400} /* G */
 ,{    530,    -80,    410,    -25,     90} /* U/T */
 }
,/* UG */
 {{    230,    165,    200,    145,   -195} /* E */
 ,{     60,     60,    -45,   -225,   -420} /* A */
 ,{    210,     85,     15,      5,   -195} /* C */
 ,{    225,    165,    -45,    145,   -420} /* G */
 ,{    230,     85,    200,      5,   -325} /* U/T */
 }
,/* AT */
 {{    745,    270,    745,    305,    500} /* E */
 ,{    545,    190,    545,    245,    500} /* A */
 ,{    745,    270,    745,    305,    385} /* C */
 ,{    545,    -60,    545,    245,    500} /* G */
 ,{    675,    270,    675,    305,     25} /* U/T */
 }
,/* UA */
 {{    230,    100,    200,      5,   -195} /* E */
 ,{    100,    100,    -45,   -225,   -420} /* A */
 ,{    210,     85,     15,      5,   -195} /* C */
 ,{    -15,   -180,    -45,   -225,   -420} /* G */
 ,{    230,     85,    200,      5,   -325} /* U/T */
 }
,/* NN */
 {{    745,    270,    745,    345,    500} /* E */
 ,{    545,    215,    545,    245,    500} /* A */
 ,{    745,    270,    745,    305,    385} /* C */
 ,{    545,    250,    545,    345,    500} /* G */
 ,{    675,    270,    675,    305,    190} /* U/T */
 }
};
PUBLIC int mismatchM37_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{    -25,    -55,    -25,    -70,    -35} /* E */
 ,{    -55,   -105,   -105,   -130,    -55} /* A */
 ,{    -35,   -110,    -65,    -75,    -80} /* C */
 ,{    -55,   -105,    -55,   -120,   -100} /* G */
 ,{    -25,    -75,    -60,   -115,    -80} /* U/T */
 }
,/* GC */
 {{    -40,    -70,    -40,    -70,    -50} /* E */
 ,{    -50,   -125,    -90,   -120,    -50} /* A */
 ,{    -55,   -115,    -80,    -75,   -100} /* C */
 ,{    -50,   -115,    -50,   -125,    -95} /* G */
 ,{    -40,    -75,    -75,   -125,   -105} /* U/T */
 }
,/* GT */
 {{    -35,    -50,    -35,    -50,    -35} /* E */
 ,{    -35,    -75,    -45,    -50,    -60} /* A */
 ,{    -40,    -50,    -40,    -90,    -40} /* C */
 ,{    -60,    -80,    -75,    -65,    -60} /* G */
 ,{    -35,    -65,    -35,    -65,    -35} /* U/T */
 }
,/* UG */
 {{    -25,    -25,    -40,    -55,    -40} /* E */
 ,{    -25,    -40,    -40,    -55,    -55} /* A */
 ,{    -45,    -60,    -45,    -95,    -50} /* C */
 ,{    -55,    -65,    -75,    -65,    -55} /* G */
 ,{    -40,    -80,    -45,    -75,    -40} /* U/T */
 }
,/* AT */
 {{    -25,    -40,    -25,    -40,    -25} /* E */
 ,{    -35,    -80,    -60,    -85,    -35} /* A */
 ,{    -30,    -60,    -40,    -40,    -45} /* C */
 ,{    -35,    -80,    -35,    -80,    -65} /* G */
 ,{    -25,    -40,    -50,    -65,    -40} /* U/T */
 }
,/* UA */
 {{    -30,    -40,    -30,    -40,    -30} /* E */
 ,{    -30,    -75,    -60,    -70,    -30} /* A */
 ,{    -35,    -65,    -45,    -50,    -55} /* C */
 ,{    -30,    -65,    -30,    -60,    -55} /* G */
 ,{    -35,    -50,    -50,    -75,    -60} /* U/T */
 }
,/* NN */
 {{    -15,    -15,    -25,    -25,    -25} /* E */
 ,{    -15,    -40,    -40,    -50,    -30} /* A */
 ,{    -30,    -50,    -40,    -40,    -40} /* C */
 ,{    -30,    -65,    -30,    -60,    -55} /* G */
 ,{    -25,    -40,    -35,    -65,    -35} /* U/T */
 }
};
PUBLIC int mismatchMdH_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{    -20,   -245,    -20,   -245,    -60} /* E */
 ,{   -570,   -570,   -670,   -665,   -670} /* A */
 ,{   -140,   -365,   -140,   -365,   -180} /* C */
 ,{   -535,   -535,   -615,   -565,   -615} /* G */
 ,{   -245,   -245,   -255,   -245,   -295} /* U/T */
 }
,/* GC */
 {{   -345,   -490,   -345,   -490,   -475} /* E */
 ,{   -515,   -685,   -515,   -640,   -515} /* A */
 ,{   -380,   -490,   -380,   -490,   -475} /* C */
 ,{   -515,   -515,   -520,   -695,   -520} /* G */
 ,{   -385,   -530,   -385,   -530,   -680} /* U/T */
 }
,/* GT */
 {{    270,   -125,     25,    270,    185} /* E */
 ,{    270,   -125,   -100,    270,   -100} /* A */
 ,{     15,   -230,   -170,   -230,     15} /* C */
 ,{    -40,   -410,   -180,    -40,   -180} /* G */
 ,{   -220,   -605,   -380,   -605,   -220} /* U/T */
 }
,/* UG */
 {{    415,    215,    415,    215,    345} /* E */
 ,{   -180,   -320,   -265,   -180,   -265} /* A */
 ,{    295,     95,    295,     95,    225} /* C */
 ,{   -210,   -270,   -210,   -270,   -210} /* G */
 ,{    215,    215,    100,    215,    195} /* U/T */
 }
,/* AT */
 {{    185,    -85,     25,    -75,    185} /* E */
 ,{    -75,    -85,   -100,    -75,   -100} /* A */
 ,{     15,   -230,   -170,   -230,     15} /* C */
 ,{   -180,   -410,   -180,   -410,   -180} /* G */
 ,{   -220,   -605,   -380,   -605,   -220} /* U/T */
 }
,/* UA */
 {{    560,    360,    560,    360,    490} /* E */
 ,{     85,      5,     85,     45,     85} /* A */
 ,{    560,    360,    560,    360,    490} /* C */
 ,{    120,     60,    120,     60,    120} /* G */
 ,{    315,    315,    200,    315,    130} /* U/T */
 }
,/* NN */
 {{    560,    360,    560,    415,    490} /* E */
 ,{    355,     30,     85,    355,     85} /* A */
 ,{    560,    360,    560,    360,    490} /* C */
 ,{    160,     60,    120,    160,    120} /* G */
 ,{    315,    315,    200,    315,    295} /* U/T */
 }
};
PUBLIC int mismatch1nI37_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U/T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U/T */
 }
,/* GT */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     35,     35,     35,     35} /* A */
 ,{     35,     35,     35,     35,     35} /* C */
 ,{     35,     35,     35,     35,     35} /* G */
 ,{     35,     35,     35,     35,     35} /* U/T */
 }
,/* UG */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     35,     35,     35,     35} /* A */
 ,{     35,     35,     35,     35,     35} /* C */
 ,{     35,     35,     35,     35,     35} /* G */
 ,{     35,     35,     35,     35,     35} /* U/T */
 }
,/* AT */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     35,     35,     35,     35} /* A */
 ,{     35,     35,     35,     35,     35} /* C */
 ,{     35,     35,     35,     35,     35} /* G */
 ,{     35,     35,     35,     35,     35} /* U/T */
 }
,/* UA */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     35,     35,     35,     35} /* A */
 ,{     35,     35,     35,     35,     35} /* C */
 ,{     35,     35,     35,     35,     35} /* G */
 ,{     35,     35,     35,     35,     35} /* U/T */
 }
,/* NN */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     35,     35,     35,     35} /* A */
 ,{     35,     35,     35,     35,     35} /* C */
 ,{     35,     35,     35,     35,     35} /* G */
 ,{     35,     35,     35,     35,     35} /* U/T */
 }
};
PUBLIC int mismatch1nIdH_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U/T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U/T */
 }
,/* GT */
 {{    410,    410,    410,    410,    410} /* E */
 ,{    410,    410,    410,    410,    410} /* A */
 ,{    410,    410,    410,    410,    410} /* C */
 ,{    410,    410,    410,    410,    410} /* G */
 ,{    410,    410,    410,    410,    410} /* U/T */
 }
,/* UG */
 {{    410,    410,    410,    410,    410} /* E */
 ,{    410,    410,    410,    410,    410} /* A */
 ,{    410,    410,    410,    410,    410} /* C */
 ,{    410,    410,    410,    410,    410} /* G */
 ,{    410,    410,    410,    410,    410} /* U/T */
 }
,/* AT */
 {{    410,    410,    410,    410,    410} /* E */
 ,{    410,    410,    410,    410,    410} /* A */
 ,{    410,    410,    410,    410,    410} /* C */
 ,{    410,    410,    410,    410,    410} /* G */
 ,{    410,    410,    410,    410,    410} /* U/T */
 }
,/* UA */
 {{    410,    410,    410,    410,    410} /* E */
 ,{    410,    410,    410,    410,    410} /* A */
 ,{    410,    410,    410,    410,    410} /* C */
 ,{    410,    410,    410,    410,    410} /* G */
 ,{    410,    410,    410,    410,    410} /* U/T */
 }
,/* NN */
 {{    410,    410,    410,    410,    410} /* E */
 ,{    410,    410,    410,    410,    410} /* A */
 ,{    410,    410,    410,    410,    410} /* C */
 ,{    410,    410,    410,    410,    410} /* G */
 ,{    410,    410,    410,    410,    410} /* U/T */
 }
};
PUBLIC int mismatch23I37_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -40,    -70,      0} /* A */
 ,{      0,    -40,    -25,      0,    -35} /* C */
 ,{      0,   -105,      0,    -80,    -50} /* G */
 ,{      0,      0,    -30,    -45,    -60} /* U/T */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,    -50,    -35,    -40,      0} /* A */
 ,{      0,    -50,    -30,      0,    -35} /* C */
 ,{      0,   -110,      0,    -85,    -40} /* G */
 ,{      0,      0,    -30,    -45,    -60} /* U/T */
 }
,/* GT */
 {{     25,     25,     25,     10,     25} /* E */
 ,{     25,     10,     25,     10,      5} /* A */
 ,{     25,     25,     25,    -10,     25} /* C */
 ,{     10,    -45,    -10,    -25,     10} /* G */
 ,{     25,     10,     25,     10,     10} /* U/T */
 }
,/* UG */
 {{     25,     25,     25,     10,     25} /* E */
 ,{     25,     10,     25,    -15,     10} /* A */
 ,{     25,     25,     25,     -5,     25} /* C */
 ,{     10,    -45,    -15,    -25,     10} /* G */
 ,{     25,     10,     25,     10,     10} /* U/T */
 }
,/* AT */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,      0,     20,     10,     35} /* A */
 ,{     35,      5,     25,     35,     20} /* C */
 ,{     35,    -50,     35,    -20,     10} /* G */
 ,{     35,     35,     20,     10,      0} /* U/T */
 }
,/* UA */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,      5,     15,    -15,     35} /* A */
 ,{     35,     10,     25,     35,     10} /* C */
 ,{     35,    -50,     35,    -20,     10} /* G */
 ,{     35,     35,     20,      5,      5} /* U/T */
 }
,/* NN */
 {{     35,     35,     35,     35,     35} /* E */
 ,{     35,     10,     25,     10,     35} /* A */
 ,{     35,     25,     25,     35,     25} /* C */
 ,{     35,    -45,     35,    -20,     10} /* G */
 ,{     35,     35,     25,     10,     10} /* U/T */
 }
};
PUBLIC int mismatch23IdH_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{   -210,   -230,   -210,   -235,   -250} /* E */
 ,{   -210,   -230,   -210,   -520,   -250} /* A */
 ,{   -210,   -230,   -210,   -235,   -250} /* C */
 ,{   -210,   -660,   -210,   -685,   -250} /* G */
 ,{   -210,   -230,   -210,   -235,   -570} /* U/T */
 }
,/* GC */
 {{    -45,   -310,   -165,   -255,    -45} /* E */
 ,{    -45,   -310,   -165,   -255,    -45} /* A */
 ,{    -45,   -310,   -165,   -255,    -45} /* C */
 ,{    -45,   -855,   -165,   -705,    -45} /* G */
 ,{    -45,   -310,   -165,   -255,   -365} /* U/T */
 }
,/* GT */
 {{    365,    100,    245,    155,    365} /* E */
 ,{    365,    100,    245,    155,    365} /* A */
 ,{    365,    100,    245,    155,    365} /* C */
 ,{    365,   -440,    245,   -295,    365} /* G */
 ,{    365,    100,    245,    155,     45} /* U/T */
 }
,/* UG */
 {{    365,    365,    335,    285,    -40} /* E */
 ,{    365,    365,    335,      5,    -40} /* A */
 ,{    365,    365,    335,    285,    -40} /* C */
 ,{    365,    -65,    335,   -165,    -40} /* G */
 ,{    365,    365,    335,    285,   -360} /* U/T */
 }
,/* AT */
 {{    510,    450,    510,    485,    465} /* E */
 ,{    510,    450,    510,    485,    465} /* A */
 ,{    510,    450,    510,    485,    465} /* C */
 ,{    510,    -90,    510,     35,    465} /* G */
 ,{    510,    450,    510,    485,    145} /* U/T */
 }
,/* UA */
 {{    365,    365,    335,    285,    -40} /* E */
 ,{    365,    365,    335,      5,    -40} /* A */
 ,{    365,    365,    335,    285,    -40} /* C */
 ,{    365,    -65,    335,   -165,    -40} /* G */
 ,{    365,    365,    335,    285,   -360} /* U/T */
 }
,/* NN */
 {{    510,    450,    510,    485,    465} /* E */
 ,{    510,    450,    510,    485,    465} /* A */
 ,{    510,    450,    510,    485,    465} /* C */
 ,{    510,     20,    510,     35,    465} /* G */
 ,{    510,    450,    510,    485,    145} /* U/T */
 }
};
PUBLIC int mismatchExt37_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{    -25,    -55,    -25,    -70,    -35} /* E */
 ,{    -55,   -105,   -105,   -130,    -55} /* A */
 ,{    -35,   -110,    -65,    -75,    -80} /* C */
 ,{    -55,   -105,    -55,   -120,   -100} /* G */
 ,{    -25,    -75,    -60,   -115,    -80} /* U/T */
 }
,/* GC */
 {{    -40,    -70,    -40,    -70,    -50} /* E */
 ,{    -50,   -125,    -90,   -120,    -50} /* A */
 ,{    -55,   -115,    -80,    -75,   -100} /* C */
 ,{    -50,   -115,    -50,   -125,    -95} /* G */
 ,{    -40,    -75,    -75,   -125,   -105} /* U/T */
 }
,/* GT */
 {{    -35,    -50,    -35,    -50,    -35} /* E */
 ,{    -35,    -75,    -45,    -50,    -60} /* A */
 ,{    -40,    -50,    -40,    -90,    -40} /* C */
 ,{    -60,    -80,    -75,    -65,    -60} /* G */
 ,{    -35,    -65,    -35,    -65,    -35} /* U/T */
 }
,/* UG */
 {{    -25,    -25,    -40,    -55,    -40} /* E */
 ,{    -25,    -40,    -40,    -55,    -55} /* A */
 ,{    -45,    -60,    -45,    -95,    -50} /* C */
 ,{    -55,    -65,    -75,    -65,    -55} /* G */
 ,{    -40,    -80,    -45,    -75,    -40} /* U/T */
 }
,/* AT */
 {{    -25,    -40,    -25,    -40,    -25} /* E */
 ,{    -35,    -80,    -60,    -85,    -35} /* A */
 ,{    -30,    -60,    -40,    -40,    -45} /* C */
 ,{    -35,    -80,    -35,    -80,    -65} /* G */
 ,{    -25,    -40,    -50,    -65,    -40} /* U/T */
 }
,/* UA */
 {{    -30,    -40,    -30,    -40,    -30} /* E */
 ,{    -30,    -75,    -60,    -70,    -30} /* A */
 ,{    -35,    -65,    -45,    -50,    -55} /* C */
 ,{    -30,    -65,    -30,    -60,    -55} /* G */
 ,{    -35,    -50,    -50,    -75,    -60} /* U/T */
 }
,/* NN */
 {{    -15,    -15,    -25,    -25,    -25} /* E */
 ,{    -15,    -40,    -40,    -50,    -30} /* A */
 ,{    -30,    -50,    -40,    -40,    -40} /* C */
 ,{    -30,    -65,    -30,    -60,    -55} /* G */
 ,{    -25,    -40,    -35,    -65,    -35} /* U/T */
 }
};
PUBLIC int mismatchExtdH_RD[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U/T */
 }
,/* CG */
 {{    -20,   -245,    -20,   -245,    -60} /* E */
 ,{   -570,   -570,   -670,   -665,   -670} /* A */
 ,{   -140,   -365,   -140,   -365,   -180} /* C */
 ,{   -535,   -535,   -615,   -565,   -615} /* G */
 ,{   -245,   -245,   -255,   -245,   -295} /* U/T */
 }
,/* GC */
 {{   -345,   -490,   -345,   -490,   -475} /* E */
 ,{   -515,   -685,   -515,   -640,   -515} /* A */
 ,{   -380,   -490,   -380,   -490,   -475} /* C */
 ,{   -515,   -515,   -520,   -695,   -520} /* G */
 ,{   -385,   -530,   -385,   -530,   -680} /* U/T */
 }
,/* GT */
 {{    125,   -270,   -120,    125,     40} /* E */
 ,{    110,   -285,   -260,    110,   -260} /* A */
 ,{   -100,   -345,   -285,   -345,   -100} /* C */
 ,{   -200,   -570,   -340,   -200,   -340} /* G */
 ,{   -380,   -765,   -540,   -765,   -380} /* U/T */
 }
,/* UG */
 {{    255,     55,    255,     55,    185} /* E */
 ,{   -340,   -480,   -425,   -340,   -425} /* A */
 ,{    135,    -65,    135,    -65,     65} /* C */
 ,{   -370,   -430,   -370,   -430,   -370} /* G */
 ,{     55,     55,    -60,     55,     35} /* U/T */
 }
,/* AT */
 {{     40,   -230,   -120,   -220,     40} /* E */
 ,{   -235,   -245,   -260,   -235,   -260} /* A */
 ,{   -100,   -345,   -285,   -345,   -100} /* C */
 ,{   -340,   -570,   -340,   -570,   -340} /* G */
 ,{   -380,   -765,   -540,   -765,   -380} /* U/T */
 }
,/* UA */
 {{    400,    200,    400,    200,    330} /* E */
 ,{    -75,   -155,    -75,   -115,    -75} /* A */
 ,{    400,    200,    400,    200,    330} /* C */
 ,{    -40,   -100,    -40,   -100,    -40} /* G */
 ,{    155,    155,     40,    155,    -30} /* U/T */
 }
,/* NN */
 {{    400,    200,    400,    255,    330} /* E */
 ,{    195,   -130,    -75,    195,    -75} /* A */
 ,{    400,    200,    400,    200,    330} /* C */
 ,{      0,   -100,    -40,      0,    -40} /* G */
 ,{    155,    155,     40,    155,    135} /* U/T */
 }
};
PUBLIC int dangle5_37_RD[NBPAIRS+1][5] = 
/*      E       A       C       G       U/T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -30,    -70,    -40,    -45,    -35} /* CG */
,{    -25,    -50,    -40,    -40,    -35} /* GC */
,{    -15,    -20,    -20,    -25,    -15} /* GT */
,{    -10,    -20,    -10,    -15,    -15} /* UG */
,{    -20,    -40,    -25,    -50,    -25} /* AT */
,{    -15,    -40,    -15,    -35,    -25} /* UA */
,{     -5,    -15,    -10,     -5,     -5} /* NN */
};
PUBLIC int dangle5_dH_RD[NBPAIRS+1][5] = 
/*      E       A       C       G       U/T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    120,   -430,      0,   -215,   -115} /* CG */
,{   -175,   -310,   -175,   -465,   -270} /* GC */
,{    -55,   -150,   -100,   -200,    -95} /* GT */
,{    300,   -335,    180,   -225,    -15} /* UG */
,{    125,     35,     80,    -90,   -295} /* AT */
,{    445,     15,    445,    105,     85} /* UA */
,{    445,    120,    445,    115,    210} /* NN */
};
PUBLIC int dangle3_37_RD[NBPAIRS+1][5] = 
/*      E       A       C       G       U/T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -30,    -75,    -30,    -85,    -45} /* CG */
,{    -60,   -140,    -60,   -140,   -100} /* GC */
,{    -15,    -45,    -15,    -45,    -15} /* GT */
,{    -35,    -50,    -35,    -50,    -40} /* UG */
,{    -15,    -45,    -15,    -45,    -15} /* AT */
,{    -35,    -50,    -35,    -50,    -40} /* UA */
,{    -15,    -45,    -15,    -45,    -15} /* NN */
};
PUBLIC int dangle3_dH_RD[NBPAIRS+1][5] = 
/*      E       A       C       G       U/T        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{   -150,   -465,   -150,   -520,   -455} /* CG */
,{   -330,   -850,   -330,   -585,   -570} /* GC */
,{   -160,   -685,   -160,   -445,   -305} /* GT */
,{    -55,   -340,    -55,   -475,   -390} /* UG */
,{     65,   -550,     65,   -530,    -65} /* AT */
,{    270,    -30,    270,   -150,     15} /* UA */
,{    280,    -30,    280,   -150,     20} /* NN */
};
PUBLIC int Hexaloop37_RD[40] = {};
PUBLIC int HexaloopdH_RD[40] = {};

PUBLIC char Hexaloops_RD[361] = 
  "";
PUBLIC int Tetraloop37_RD[40] = {};
PUBLIC int TetraloopdH_RD[40] = {};

PUBLIC char Tetraloops_RD[281] = 
  "";
PUBLIC int Triloop37_RD[40] = {};
PUBLIC int TriloopdH_RD[40] = {};

PUBLIC char Triloops_RD[241] = 
  "";
#include "intl11_RD.h"
#include "intl11dH_RD.h"
#include "intl21_RD.h"
#include "intl21dH_RD.h"
#include "intl22_RD.h"
#include "intl22dH_RD.h"


